(function($){
	$.infolist = function(){};
	
	$.infolist.is_loading = false;
	//加载列表页
	$.infolist.go_list = function(url, title, show_area){
		//从json数组取到该二级类的父类的listname
		if(typeof ____json4fe != 'undefined'){
			var topcate_name = '';
			if(____json4fe.catentry instanceof Array && ____json4fe.catentry.length > 0){
				topcate_name = ____json4fe.catentry[0].listname;
			}
			else{
				topcate_name = ____json4fe.catentry.listname;
			}
			if(url.indexOf("?") != -1 && topcate_name != '')
				url=url+"&topcate=" + topcate_name;
			else if(topcate_name != '')
				url=url+"?topcate=" + topcate_name;
		}
		var is_showarea = true;
		if(typeof show_area != 'undefined')
			is_showarea = show_area;
		if(url.indexOf("v=1") == -1)
			url += "&v=1";
		//从url里面分析出
		$.mclient.loadPage("list", url, title, is_showarea, false, "false");
	}
	
	//初始化列表页
	$.infolist.init_list =function(){
		if(typeof window.filter_data == 'undefined')
			return;
		var data_str = JSON.stringify(window.filter_data);
		var param = {"action":"initfilter", "data": data_str};
		$.mclient.nativeMethod(param);
		if(window.location.href.indexOf("-6=") == -1)
			$.infolist.add_history();
	}

	//筛选记录
	$.infolist.add_history = function(){
		if(____json4fe.catentry instanceof Array){
			var len = ____json4fe.catentry.length;
			if(len < 2)
				return;
			var _catename = ____json4fe.catentry[1].name;
			var _cateid = ____json4fe.catentry[1].dispid;
		}else{
			var _catename = ____json4fe.catentry.name;
			var _cateid = ____json4fe.catentry.dispid;
		}
		if(____json4fe.locallist instanceof Array){
			var len = ____json4fe.locallist.length;
			var _localname = ____json4fe.locallist[len-1].name;
			}
		else{
			var _localname = ____json4fe.locallist.name;
		}
		var _title = "";
		for(var paraname in window.filter_data.unitparas){
			var data = window.filter_data.unitparas[paraname].data;
			var _id = window.filter_data.unitparas[paraname].id;
			if(_id == "local" || _id == "keywords" || _id == "sort")
				continue;
			for(var i in data){
				var item = data[i];
				if(typeof item.selected == 'undefined')
					continue;
				if(item.selected == "true" && (item.txt != "全部" && item.txt != "不限")){
					_title += "/" + item.txt;
				}
			}
		}
		if(_title != "")
			_title = _localname + _title;
		else
			_title = _localname + "/" + _catename;
		$.my.add_history(window.location.href, _title, "filter", _localname, _catename, "", _cateid);
	}
	
	$.infolist.go_detail = function(li_obj){
		var $li_obj = $(li_obj);
		var title = $li_obj.find(".tit").text();
		var url = $li_obj.attr("url");
		if(typeof url != 'undefined')
			$.mclient.loadPage("detail", url, '详情', false, false, "false");
	}
	//下一页
	$.infolist.next_page = function(){
		if($.infolist.is_loading)
			return false;
		$.infolist.is_loading = true;
		Mclient.showBgLayer();
		var nextPageUrl = pageUrlFormat.replace("@page@", String(++currPageNum));
		$(".view_more").addClass("lst_loading").html("<span class='ico_loading'></span>正在加载中...");
		$.ajax({type:"GET", url: nextPageUrl, success:function(resp){
			Mclient.hideBgLayer();
			if($.trim(resp) == ''){
				var str_info = "<div class='not_more_info'>没有更多信息了</div>";
				if(window.location.href.indexOf("-6=") > -1)
					str_info = "<div class='not_more_info nearby_more'>没有更多信息了</div>";
				$(".scroll_div").append(str_info);
				$(".view_more").hide();
				return;
			}
			$(".infolst_w").append(resp);
			$.infolist.is_loading = false;
			$(".view_more").removeClass("lst_loading").html("<span class='ico_loading'></span>查看更多");
			var isIOS4orMeizu = false;
			if($.os.ios && $.mclient.getOS() == 'ios' && navigator.appVersion.toLowerCase().indexOf("os 4") > -1){
				isIOS4orMeizu = true;
			}
			if($.mclient.isMeizu==true){
				isIOS4orMeizu = true;
			}
			if(isIOS4orMeizu){
				$(".infolst").imglazyload({
					container:"#ct",
					event:"touchend"
				});
				$.mclient.infoScroll.refresh();
			}else{
				$(".infolst").imglazyload();
			}
			Mclient.infoListIconStyle();
			Mclient.touchStyle(".infolst li","hover");
			Mclient.gotoDetail();
		}, timeout : 30000, error:function(msg){
			//$.common.toast('网络超时,请稍后再试');
			$.infolist.is_loading = false;
			$(".view_more").removeClass("lst_loading").html("<span class='ico_loading'></span>加载失败请重试");
			Mclient.hideBgLayer(); 
		}});
	}

	$.infolist.premap = function(type){
		var url = window.location.href;
			url = url.replace('&-6=0', '');
			url = url.replace('-6=0', '');
			url += '&-6=1';
			$.infolist.switchmap('showmap', url, '');
	}

	//@param cmd showmap/hidemap	
	$.infolist.switchmap = function(cmd, mapurl, pageurl){
		var param = {"action":"switchmap", "cmd":cmd, "mapurl":mapurl, "pageurl": pageurl};
		$.mclient.nativeMethod(param);
	}
	//加载附近列表页
	$.infolist.go_nearlist = function(url, title){
		url = url.replace('/lbs/', '/@location@/');
		if(url.indexOf("v=1") == -1)
			url += "&v=1";
		$.mclient.loadPage("nearlist", url, title, true, false, "true");
	}
	//更新新区域
	$.infolist.set_local = function(localid, localname, listname){
		var param = {"action":"setlocal", "name":localname, "listname":listname};
		$.mclient.nativeMethod(param);
	}
	
	//区域切换
	$.infolist.change_local = function(local){
		if(typeof(window.localUrlFormat) != 'undefined'){
			if(window.localUrlFormat.indexOf("v=1") == -1)
				window.localUrlFormat += "&v=1";
			window.location.href = window.localUrlFormat.replace('@local@', local);
		}
	}
	
	$.infolist.set_catedata = function(data){
		var param = {"action":"category_data", "data":data};
		$.mclient.nativeMethod(param);
	}

	$.infolist.get_catedata = function(mod){
		if(mod == "nearby")
			var _cate_data = window.childcate;
		else
			var _cate_data = window.sou_catedata;
		if('undefined' != typeof _cate_data)
			$.infolist.set_catedata(_cate_data);
		return true;
	}

	$.infolist.change_cate = function(listname, catename, page_mod){
		var url = window.cateUrlFormat.replace('@cate@', listname);
		if(url.indexOf("http://") == -1)
			url = "http://" + $.mclient.root_domain + url;
		$.common.set_title(catename);
		if(page_mod == 'map'){
			$.infolist.switchmap('showmap', url, '');
			return;	
		}
		window.location.href = url;
	}

 $.infolist.removeUrlKeyPair =  function(url,key){
      var reg = new RegExp(key+"=[^&]*","gmi");
          url = url.replace(reg,"");
          if(url.indexOf('&')==url.length-1)url = url.substring(0,url.length - 1);
          if(url.indexOf('?')==url.length-1)url = url.substring(0,url.length - 1);
          if(url.indexOf("?&")>-1)url = url.replace("?&","?");
          return url;
   }
	//本类搜
	$.infolist.localsou = function(key){
			var url = window.location.href ;
			url = $.infolist.removeUrlKeyPair(url,"key");
			if(url.indexOf("http://") == -1)
					url = "http://" + $.mclient.root_domain + url;
			if(filter_data.type == "cmcs"){
					var reg = new RegExp("(http://[a-zA-Z]+\.58\.com)/([a-zA-z]+)/.+(\\?.*)","gmi");
				url = url.replace(reg,"$1/$2/"+____json4fe.catentry[1].listname+"/$3");
			}
			url = url.replace(/\??&key=[^&]*/, '');
			if(url.indexOf('?')>0){
					url = url + "&key=" + key;
			}else{
				url = url + "?key=" + key;
			}
	window.location.href = url;
	}
	//无结果统计
	$.infolist.noresult = function(){
		var nr_type = "list";
		var url = window.location.href;
		if(url.indexOf("key=") > -1)
			nr_type = "sou";
		var param = {"action":"noresult", "type":nr_type, "url": url};
		$.mclient.nativeMethod(param);
	}

})(jq);
