/*
 Mclient.ui v1.0
 author:luoronghang
 date:2012/05/12   
*/
if(typeof(Mclient)=="undefined"){	
	var Mclient={};
}
Mclient.toggleDropSelect=function(w,t,c){
	if(document.querySelector(w) == null)
		return;
	$(w).find(t).each(function(i){
		var self = $(this);
		var currEle = $(w).find(c).get(i);
		var iScroll = false;		
		if(typeof(currEle)=="undefined"){
			return;
		}else{
			self.append("<i class='arrow'></i>");
		}
		self.bind("touchstart",function(){iScroll = false});
		self.bind("touchmove",function(){iScroll = true});
		self.bind("touchend",function(){
			if(iScroll){return}
			if($(currEle).css("display")=="none"){
				$(currEle).css("display","block");
				self.addClass("open");				
			}else{
				$(currEle).css("display","none");
				self.removeClass("open");
			}	
		});
	});
};
Mclient.toggleShow=function(t,c,sty){
	$(t).bind("click",function(){
		if($(c).css("display")=="none"){
			$(c).show();
			$(this).addClass(sty);
		}else{
			$(c).hide();
			$(this).removeClass(sty);
		}
	});
};

Mclient.showContact=function(){
	//暂时无用
	var winH = window.innerHeight;
	var docH = document.body.offsetHeight;
	var maxH = Math.max(winH,docH);
	$(window).bind("resize",function(){
		winH = window.innerHeight;
		maxH = Math.max(winH,docH);
	});
	var popLayer = $(".contact_way_pop");
	var bgLayer=$(".bg_layer");
	bgLayer.bind("touchmove",function(e){
		e.preventDefault();
	});
	popLayer.bind("touchmove",function(e){
		e.preventDefault();
	});
	$(".contact_bar").bind("touchmove",function(e){
		e.preventDefault();
		e.stopPropagation();
	});
	$("#btn_contact").bind("click",function(e){
		e.stopPropagation();
		if(popLayer.css("display")=="none"){
			bgLayer.show();
			bgLayer.css("height",maxH+"px");
			$(window).bind("resize",function(){
				bgLayer.css("height",maxH+"px");
			});
			popLayer.show();
			setTimeout(function(){popLayer.css("bottom","70px");},200);			
		}else{
			hidePopLayer();
		}
	});
	bgLayer.bind("click",function(){
		hidePopLayer();
	});	
	$(".contact_way_pop_inner").bind("click",function(){
		hidePopLayer();
	});
	var hidePopLayer=function(){
		popLayer.css("bottom","-35px");
		setTimeout(function(){
			bgLayer.hide();
			popLayer.hide();
		},250);	
	};
};
Mclient.thumbImageLoad=function(){
	//详情页图片异步
	var image_area = $(".image_area");
	if(image_area.length){
		var tagImg = image_area.find("img");
		tagImg.each(function(){
			var self = $(this);
			var ImgUrl = $(this).attr("ref");		
			self.attr("src",ImgUrl);
		});
	}
};

//附近列表当前位置层定位
Mclient.currLocationLayer=function(){	
	var ctW = parseInt($("#ct").css("width"))-15;
	$(".curr_location").css({width:ctW+"px",left:"5px"});
	$(window).bind("resize",function(){
		ctW = parseInt($("#ct").css("width"))-15;
		$(".curr_location").css({width:ctW+"px",left:"5px"});
	});
};

Mclient.infoDetailShowBigPic=function(){
	if($(".image_area").length){
		var text_arr = $(".titbar h1").text();
		var imgs=[];
		var pic_arr;
		$(".image_area").find("img").each(function(index){						
			imgs.push($(this).attr("ref").replace("tiny","big"));
			pic_arr = imgs.join();
			$(this).bind("click",function(){				
				$.infodetail.showpic(pic_arr, index, text_arr);		
			});
		});
	}
};

Mclient.detailAttrStyle=function(){
	if(!$(".attr_info").length){return}
	$(".attr_info").find(".attrName").each(function(){
		if($(this).text().length<4){
			var strs = $(this).text().substr(0,1);
			var stre = $(this).text().substr(1);
			$(this).html(strs+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+stre);
		}
	});
};

Mclient.infoListIconStyle=function(){
	if(!$(".infolst").length){return}
	var currUl = $(".infolst");
	var currUlIndex = currUl.length-1;	
	$(currUl.get(currUlIndex)).find("li").each(function(){
		var tagi = $(this).find("dt i");
		if(tagi.length==1){
			$(this).find("strong").css("padding-right","40px");
		}else if(tagi.length==2){
			$(this).find("strong").css("padding-right","55px");
			$(this).find(".biz").css("right","20px");
		}
	});	
};
Mclient.touchStyle=function(obj,hover){
	$(obj).bind("touchstart",function(){
		$(this).addClass(hover);
	});	
	$(obj).bind("touchmove",function(){
		$(this).removeClass(hover);
	});
	$(obj).bind("touchend",function(){
		$(this).removeClass(hover);
	});
	$(obj).bind("touchcancel",function(){
		$(this).removeClass(hover);
	});
};

//显示透明背景层
Mclient.showBgLayer=function(){
	if(!$(".bg_layer").length){
		$("#ct").append("<div class='bg_layer'></div>");
	}
	var bg_layer = $(".bg_layer");
	bg_layer.css({"height":window.innerHeight+"px","display":"block"});
	$(window).bind("resize",function(){
		bg_layer.css({"height":window.innerHeight+"px"});
	});
	bg_layer.bind("touchmove",function(e){
		e.preventDefault();
	});	
};

//隐藏透明背景层
Mclient.hideBgLayer=function(){
	$(".bg_layer").hide();
};

//列表页跳转
Mclient.gotoDetail=function(){
	if($(".infolst").length){
		var infolst=$(".infolst");
		var currLst = $(infolst.get(infolst.length-1));
		currLst.find("li").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});
		currLst.find("li").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		currLst.find("li").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}			
			$.infolist.go_detail(this);		
		});
	}
};

//页面滚动效果处理(为兼容ios4.x and meizu mx)
Mclient.pageScroll=function(){

    //初始化滚动事件
    function initScroll(){
        $("#ct").css({"-webkit-backface-visibility":"hidden"});
        $("#ct > *").css({"-webkit-backface-visibility":"hidden"});
        $("#ct").addClass("active");
        $(".tab_menu").css({"left":"0","position":"absolute"});
        $(".contact_bar").css({"left":"0","position":"absolute"});
    }

    //大类页
    var ctg_w = $(".ctg_w");
    if(ctg_w.length){
        initScroll();
        $("#ct").css({"position":"relative"});
        ctg_w.parent().css({"height":window.innerHeight+"px","overflow":"hidden"});
        ctg_w.scroller({
            scrollBars: true,
            verticalScroll: true,
            horizontalScroll: false,
            vScrollCSS: "jqmScrollbar",
            hScrollCSS: "jqmScrollbar"
        });
    }

    //详情页
    var detail_w = $(".detail_w");
    if(detail_w.length){
        initScroll();
        $("#ct").css({"position":"relative"});
        detail_w.parent().css({"height":window.innerHeight+"px","overflow":"hidden"});
        detail_w.scroller({
            scrollBars: true,
            verticalScroll: true,
            horizontalScroll: false,
            vScrollCSS: "jqmScrollbar",
            hScrollCSS: "jqmScrollbar"
        });
        if(!$(".contact_bar").length){
            $(".detail_w").css("padding-bottom","0");
        }
    }

    // 附近列表页,列表页
    $.mclient.infoScroll=null;
    function listScroll(){
        initScroll();
        $("#ct").addClass("ios4_scroll");
        $.mclient.infoScroll = new iScroll('ct',{scrollbarClass: 'myScrollbar'});
        document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);
    }
    if($(".tab_menu").length && $(".scroll_div").length){
        listScroll();
        $(".curr_location").css("position","absolute");
    }else if($(".scroll_div").length){
        listScroll();
    }

};

// 延迟加载插件
(function($){
	$.fn.imglazyload=function(options){
		
		var defaults={
			container:window,
			event:"scroll",
			imgattr:"ref"
		}
		var opts = $.extend(defaults,options);
		
		//取元素的页面绝对 X位置
		 var getLeft = function(El){
			 var left = 0;
			 do{
				 left += El.offsetLeft;
			 }while((El = El.offsetParent).nodeName != 'BODY');
			 return left;
		 };
		 
		 //取元素的页面绝对 Y位置
		 var getTop = function(El){
			 var top = 0;
			 do{
				 top += El.offsetTop;
			 }while((El = El.offsetParent).nodeName != 'BODY');
			 return top;
		 };
		
		var _this = $(this);
		if(!_this.length){return}
		var _thisIndex = _this.length-1;		
		var imgs = $(_this.get(_thisIndex)).find("img");

		function loadImg(){
			if(opts.container!=window){
				//图片容器 
				var container =$(opts.container);
				var containerHeight=parseInt(container.css("height"));
				for(var i=0 ; i < imgs.length; i++){
					var imgTop = imgs[i].getBoundingClientRect().top;
					//判断图片是否在显示区域内	
					if(imgTop <= containerHeight){
						var imgUrl = $(imgs[i]).attr(opts.imgattr);
						//如果图片已经显示，则取消赋值
						if(imgs[i].src !== imgUrl){
							imgs[i].src = imgUrl;
						}
					}
				}
			}else{
				var isWebkit = !!navigator.userAgent.match(/AppleWebKit\b/img);
				var _scrollTop = isWebkit ? document.body.scrollTop : document.documentElement.scrollTop,
					_scrollLeft = isWebkit ? document.body.scrollLeft : document.documentElement.scrollLeft,
					_visibleWidth = document.documentElement.clientWidth,
					_visibleHeight = document.documentElement.clientHeight;
					
				//对所有图片进行批量判断是否在浏览器显示区域内
				for(var i=0 ; i < imgs.length; i++){
					var imgTop = getTop(imgs[i]),
						imgLeft = getLeft(imgs[i]);
					//判断图片是否在显示区域内
					if( imgTop >= _scrollTop && imgLeft >= _scrollLeft && imgTop <= _scrollTop+_visibleHeight && imgLeft <= _scrollLeft+_visibleWidth){
						var imgUrl = $(imgs[i]).attr(opts.imgattr);
						//如果图片已经显示，则取消赋值
						if(imgs[i].src !== imgUrl){
							imgs[i].src = imgUrl;
						}
					}
				} 	
			}
		}
		
		//执行事件处理
		loadImg();	
		$(opts.container).bind(opts.event,loadImg);		
	};
})(jq);

//Touch events are from zepto/touch.js
(function($) {
    var touch = {}, touchTimeout;

    function parentIfText(node) {
        return 'tagName' in node ? node : node.parentNode;
    }

    function swipeDirection(x1, x2, y1, y2) {
        var xDelta = Math.abs(x1 - x2), yDelta = Math.abs(y1 - y2);
        if (xDelta >= yDelta) {
            return (x1 - x2 > 0 ? 'Left' : 'Right');
        } else {
            return (y1 - y2 > 0 ? 'Up' : 'Down');
        }
    }

    var longTapDelay = 1000;
    function longTap() {
        if (touch.last && (Date.now() - touch.last >= longTapDelay)) {
            touch.el.trigger('longTap');
            touch = {};
        }
    }
    $(document).ready(function() {
        $(document.body).bind('touchstart', function(e) {
            var now = Date.now(), delta = now - (touch.last || now);
            touch.el = $(parentIfText(e.touches[0].target));
            touchTimeout && clearTimeout(touchTimeout);
            touch.x1 = e.touches[0].pageX;
            touch.y1 = e.touches[0].pageY;
            if (delta > 0 && delta <= 250)
                touch.isDoubleTap = true;
            touch.last = now;
            setTimeout(longTap, longTapDelay);
           // if (!touch.el.data("ignore-pressed"))
                //touch.el.addClass("selected");
           // else
                //touch.el.closest(".selectable").addClass("selected");
        }).bind('touchmove', function(e) {
            touch.x2 = e.touches[0].pageX;
            touch.y2 = e.touches[0].pageY;
        }).bind('touchend', function(e) {
            if (!touch.el) {
                touch = {};
                return;
                }
            //if (!touch.el.data("ignore-pressed"))
               // touch.el.removeClass("selected");
           // else
               // touch.el.closest(".selectable").removeClass("selected");
            if (touch.isDoubleTap) {
                touch.el.trigger('doubleTap');
                touch = {};
            } else if (Math.abs(touch.x1 - touch.x2) > 5 || Math.abs(touch.y1 - touch.y2) > 5) {
                (Math.abs(touch.x1 - touch.x2) > 30 || Math.abs(touch.y1 - touch.y2) > 30) &&
                touch.el.trigger('swipe') &&
                touch.el.trigger('swipe' + (swipeDirection(touch.x1, touch.x2, touch.y1, touch.y2)));
                touch.x1 = touch.x2 = touch.y1 = touch.y2 = touch.last = 0;
            } else if ('last' in touch) {
                touch.el.trigger('tap');
                touchTimeout = setTimeout(function() {
                    touchTimeout = null;
                    if (touch.el)
                        touch.el.trigger('singleTap');
                    touch = {};
                }, 250);
            }
        }).bind('touchcancel', function() {
            touch = {}
        });
    });

    ['swipe', 'swipeLeft', 'swipeRight', 'swipeUp', 'swipeDown', 'doubleTap', 'tap', 'singleTap', 'longTap'].forEach(function(m) {
        $.fn[m] = function(callback) {
            return this.bind(m, callback)
        }
    });
})(jq);

//dom解析完成后执行
document.addEventListener("DOMContentLoaded",function(){
	
	//列表页icon显示
	Mclient.infoListIconStyle();

	//检查系统是否为ios4，处理页面滚动
	if($.os.ios && navigator.appVersion.toLowerCase().indexOf("os 4") > -1){

		Mclient.pageScroll();

    }else if($.os.ios && $.mclient.getOS() == 'ios'){
		$(".tab_menu").css("left","0");
		$(".contact_bar").css("left","0");
		if(!$(".contact_bar").length){
			$(".detail_w").css("padding-bottom","0");
		}
	}else{
		if(!$(".contact_bar").length){
			$(".detail_w").css("padding-bottom","0");
		}
	}
	
	// dom 解析完成，处理页面跳转
	$.mclient.ismove=false;
	var fingerNum;
	
	//首页跳转
	if($(".nav").length){		
		$(".nav").find("li").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});		
		$(".nav").find("li").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		$(".nav").find("li").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}
			var url = $(this).attr("url");
			var title = $(this).attr("title");
			var pubbtn=$(this).attr("pubbtn");
			if(title=="团购"){
				$.index.go_groupbuy(url,title);
			}else{
				$.index.load_childcate(url,title,pubbtn);
			}
		});
	}
	
	//大类页跳转
	if($(".ctg_lst").length){
		$(".ctg_lst").find("dt").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});
		$(".ctg_lst").find("dt").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		$(".ctg_lst").find("dt").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}
			var url = $(this).attr("url");
			var title = $(this).attr("title");
			var show_area=$(this).attr("show_area")=="false"?false:true;
			$.infolist.go_list(url,title,show_area);		
		});
		
		//有二级类别跳转
		$(".ctg_lst").find("li").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});
		$(".ctg_lst").find("li").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		$(".ctg_lst").find("li").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}
			var url = $(this).attr("url");
			var title = $(this).attr("title");
			$.infolist.go_list(url,title);		
		});
	}
	
	//热门职位跳转
	if($(".job_hots_box").length){
		$(".job_hots_box").find("li").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});
		$(".job_hots_box").find("li").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		$(".job_hots_box").find("li").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}
			var url = $(this).attr("url");
			var title = $(this).attr("title");
			$.infolist.go_list(url,title);		
		});
	}
	
	//查看更多
	if($(".view_more").length){
		$(".view_more").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});
		$(".view_more").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		$(".view_more").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}
			$.infolist.next_page();	
		});
	}	
	
	//列表页跳转
	Mclient.gotoDetail();
	
	//规格参数，公司介绍 跳转
	if($(".other_info").length){
		$(".other_info").bind("touchstart",function(e){
			$.mclient.ismove=false;
			fingerNum= e.touches.length;
		});
		$(".other_info").bind("touchmove",function(){
			$.mclient.ismove=true;
		});
		$(".other_info").bind("touchend",function(){
			if($.mclient.ismove||fingerNum>1){return;}
			if($(this).text()=="规格参数"){
				$.mclient.loadPage("link",window.location.href+"&-4=0", "规格参数", false);
			}else if($(this).text()=="物品描述"){
				$.mclient.loadPage("link",window.location.href+"&-4=1", "物品描述", false);
			}else if($(this).text()=="公司介绍"){
				$.mclient.loadPage("link",window.location.href+"&-4=2", "公司介绍", false);
			}
		});
	}	
	
},false);

$(function(){
	Mclient.toggleDropSelect(".ctg_lst","dt","dd");	
	Mclient.toggleShow("#xbInfo",".xb_pop_layer","open");
	Mclient.currLocationLayer();
	Mclient.infoDetailShowBigPic();
	Mclient.detailAttrStyle();
	Mclient.touchStyle("#btn_contact","hover");
	Mclient.touchStyle(".infolst li","hover");
	Mclient.touchStyle(".ctg_lst dt","hover");
	Mclient.touchStyle(".other_info","hover");
	Mclient.touchStyle(".ctg_lst li","hover");
	Mclient.touchStyle(".job_hots_box span","hover");
	Mclient.touchStyle(".view_more","hover");
	Mclient.touchStyle(".tab_menu li","hover");
	Mclient.touchStyle(".contact_way li","hover");
	
	//首页触摸效果	
	if($(".nav").length){
		$(".nav").find(".ico").bind("touchstart",function(e){
			$(this).find(".ico_hover").css("display","block");
		});
		$(".nav").find(".ico").bind("touchmove",function(e){
			$(this).find(".ico_hover").css("display","none");
		});
		$(".nav").find(".ico").bind("touchend",function(e){
			$(this).find(".ico_hover").css("display","none");
		});
		$(".nav").find(".ico").bind("touchcancel",function(e){
			$(this).find(".ico_hover").css("display","none");
		});
	}
	//图片延迟加载
	if($.os.ios && navigator.appVersion.toLowerCase().indexOf("os 4") > -1){
			if($(".infolst").length){
				setTimeout(function(){
					$.mclient.infoScroll.refresh();
				},3000);
			}
			$(".infolst").imglazyload({
				container:"#ct",
				event:"touchend"
			});	
			Mclient.thumbImageLoad();
			
	}else if($.os.ios && $.mclient.getOS() == 'ios'){
		$(".infolst").imglazyload();
		Mclient.thumbImageLoad();
		
	}else{		
		setTimeout(function(){			
			$(".infolst").imglazyload();
			Mclient.thumbImageLoad();
		},100);		
	}

    // 处理魅族手机的bug
    $.mclient.isMeizu=false;
    if(document.cookie!=""){
        var cookiesArray=document.cookie.split(";");
        for(i=0;i<cookiesArray.length;i++){
            var cookieList=cookiesArray[i];
            var separator = cookieList.indexOf("=");
            var _name= cookieList.substring(0,separator);
            var _val=cookieList.substring(separator+1);
            var _newVal=decodeURIComponent(_val);
            if(_newVal.indexOf("Meizu")>-1){
                $.mclient.isMeizu=true;
            }
        }
    }
    if($(".ctg_w").length){
        var _url = window.location.href;
        if(_url.indexOf("Meizu") > -1){
            Mclient.pageScroll();
        }
    }else{
        if($.mclient.isMeizu == true){
            Mclient.pageScroll();
            if($(".infolst").length){
                setTimeout(function(){
                    $.mclient.infoScroll.refresh();
                },3000);
            }
            $(".infolst").imglazyload({
                container:"#ct",
                event:"touchend"
            });
            console.log("is meizu");
        }else{
            console.log("not meizu");
        }
    }

});
