    (function($){
		trimLeft = /^\s+/;
		trimRight = /\s+$/;
		trim = String.prototype.trim;
		$.trim = trim ?
			function( text ) {
				return text == null ?
					"" :
					trim.call( text );
			} :
			// Otherwise use our own trimming functionality
			function( text ) {
				return text == null ?
					"" :
					text.toString().replace( trimLeft, "" ).replace( trimRight, "" );
			};

            $.mclient = function () {};
            $.mclient.page_finished = "false";
			$.mclient.root_domain = "webapp.58.com";
			$.mclient.getOS = function(){
            	var queryString = window.location.search;
            		queryString = queryString.toLowerCase();
            	if(queryString.indexOf("os=android") > -1)
            		return "android";
            	if(queryString.indexOf("os=wp") > -1)
            		return "wp";
            	return "ios";
            }
            $.mclient.iosNative = function(param){
				//var cmd = "objc://native/";
				//post(cmd, {"paras":param});
				$.post("http://" + document.location.host + "/nativechannel/", 
					{"paras":param}, 
					function(rsp){
				});
            }
            $.mclient.androidNative = function(param){
            	if(typeof window.stub == 'undefined')
            	{
            		alert('stub is null');
            		return;
            	}	
            	window.stub.jsCallMethod(param);
            }
            $.mclient.wpNative = function(param){
            	if(typeof window.external == 'undefined' || typeof window.external.notify == 'undefined'){
            		alert('unknow device');
            		return;
            	}
            	window.external.notify(param);
            }
            //Native 方法统一入口
            $.mclient.nativeMethod = function(param){
            	if(typeof param == 'undefined')
        		{
            		alert('param error');
        		}
            	var strJson = JSON.stringify(param);
            	if($.mclient.getOS() == "ios")
            		$.mclient.iosNative(strJson);
            	else if($.mclient.getOS() == "android")
            		$.mclient.androidNative(strJson);
            	else if($.mclient.getOS() == "wp")
            		$.mclient.wpNative(strJson);
            }
			$.mclient.loadPage = function(pagetype, url, title, is_showarea, is_showpub, is_finish){
				var show_area = "false";
				if(is_showarea)
					show_area = "true";
				var param = {"action": "loadpage", "pagetype" : pagetype, "url":url, "title":title,"showarea": show_area, "showpub": is_showpub, "isfinish":is_finish};
				$.mclient.nativeMethod(param);
			}
		
        })(jq);
		
        (function($){
			$.common = function(){};

			//拨打电话
			$.common.tel = function(phonenum, infoid, len){
				var param = {"action":"tel", "phonenum":phonenum, "infoid": infoid, "len":len};
				$.mclient.nativeMethod(param);
			}
			//发短信
			$.common.sms = function(phonenum, content, len, infoid){
				var param = {"action":"sms", "phonenum":phonenum, "content": content, "len":len, "infoid": infoid};
				$.mclient.nativeMethod(param);
			}

			$.common.im = function(uid, uname, nickname, online, title, url, infoid){
				var param = {"action":"im","uid": uid,"uname":uname,"nickname": nickname,"online": online, "title":title, "url":url, "infoid":infoid};
				$.mclient.nativeMethod(param);
			}
			//清除指定URL的缓存
			$.common.clear_cache = function(url){
				var param = {"action":"clearcache", "url":url};
				$.mclient.nativeMethod(param);
			}
			//设 置当前VIEW的标题	
			$.common.set_title = function(title, cmd){
				if(typeof cmd == 'undefined')
					var cmd = "";
				var param = {"action":"changetitle", "title":title, "rightbtn": cmd};
				$.mclient.nativeMethod(param);
			}
			//页面加载完成时通知IOS
			$.common.page_finish = function(){
				//if($.mclient.getOS() != "ios")
				//	return;
				console.debug('page_finished');
				var call_set = "";
				if(typeof window.reversecall != 'undefined')
					call_set = window.reversecall;
				var param = {"action":"page_finish", "reversecall": call_set};
				$.mclient.nativeMethod(param);
			}
			//控制客户端返回到上一界面
			$.common.go_back = function(){
				var param = {"action":"goback"};
				$.mclient.nativeMethod(param);
			}
			
			$.common.go_anylink = function(url, title){
				$.mclient.loadPage("link", url, title, "false", false, "false");
			}

			//加载状态
			//@param cmd "show/hide"
			$.common.loadingbar = function(cmd){
				var param = {"action":"loadingbar", "cmd":cmd};
				$.mclient.nativeMethod(param);
			}
			//通过native显示提示信息
			$.common.toast = function(msg){
				var param = {"action":"toast","msg":msg};
				$.mclient.nativeMethod(param);
			}
    
			$(function(){
				//alert('test');
				$.common.page_finish();
			});
		})(jq);

	LazyLoad = (function (win, doc) {
	  var env,
	  head,
	  pending = {},
	  pollCount = 0,
	  queue = {css: [], js: []},
	  styleSheets = doc.styleSheets;

	  function createNode(name, attrs) {
	    var node = doc.createElement(name), attr;
	    for (attr in attrs) {
	      if (attrs.hasOwnProperty(attr)) {
	        node.setAttribute(attr, attrs[attr]);
	      }
	    }
	    return node;
	  }

	  function finish(type) {
	    var p = pending[type],
	        callback,
	        urls;

	    if (p) {
	      callback = p.callback;
	      urls     = p.urls;

	      urls.shift();
	      pollCount = 0;

	      if (!urls.length) {
	        if (callback) {
	          callback.call(p.context, p.obj);
	        }

	        pending[type] = null;

	        if (queue[type].length) {
	          load(type);
	        }
	      }
	    }
	  }

	  function getEnv() {
	    if (env) { return; }

	    var ua = navigator.userAgent;

	    env = {
	      async: doc.createElement('script').async === true
	    };

	    (env.webkit = /AppleWebKit\//.test(ua))
	      || (env.ie = /MSIE/.test(ua))
	      || (env.opera = /Opera/.test(ua))
	      || (env.gecko = /Gecko\//.test(ua))
	      || (env.unknown = true);
	  }

	  function load(type, urls, callback, obj, context) {
	    var _finish = function () { finish(type); },
	        isCSS   = type === 'css',
	        i, len, node, p, pendingUrls, url;

	    getEnv();

	    if (urls) {
	      urls = typeof urls === 'string' ? [urls] : urls.concat();
	      if (isCSS || env.async || env.gecko || env.opera) {
	        queue[type].push({
	          urls    : urls,
	          callback: callback,
	          obj     : obj,
	          context : context
	        });
	      } else {
	        for (i = 0, len = urls.length; i < len; ++i) {
	          queue[type].push({
	            urls    : [urls[i]],
	            callback: i === len - 1 ? callback : null, 
	            obj     : obj,
	            context : context
	          });
	        }
	      }
	    }

	    if (pending[type] || !(p = pending[type] = queue[type].shift())) {
	      return;
	    }

	    head || (head = doc.head || doc.getElementsByTagName('head')[0]);
	    pendingUrls = p.urls;

	    for (i = 0, len = pendingUrls.length; i < len; ++i) {
	      url = pendingUrls[i];

	      if (isCSS) {
	        node = createNode('link', {
	          charset: 'utf-8',
	          'class': 'lazyload',
	          href   : url,
	          rel    : 'stylesheet',
	          type   : 'text/css'
	        });
	      } else {
	        node = createNode('script', {
	          charset: 'utf-8',
	          'class': 'lazyload',
	          src    : url
	        });

	        node.async = false;
	      }

	      if (env.ie) {
	        node.onreadystatechange = function () {
	          var readyState = this.readyState;

	          if (readyState === 'loaded' || readyState === 'complete') {
	            this.onreadystatechange = null;
	            _finish();
	          }
	        };
	      } else if (isCSS && (env.gecko || env.webkit)) {
	        if (env.webkit) {
	          p.urls[i] = node.href; 
	          poll();
	        } else {
	          setTimeout(_finish, 50 * len);
	        }
	      } else {
	        node.onload = node.onerror = _finish;
	      }

	      head.appendChild(node);
	    }
	  }

	  function poll() {
	    var css = pending.css, i;

	    if (!css) {
	      return;
	    }
	    i = styleSheets.length;
	    while (i && --i) {
	      if (styleSheets[i].href === css.urls[0]) {
	        finish('css');
	        break;
	      }
	    }

	    pollCount += 1;

	    if (css) {
	      if (pollCount < 200) {
	        setTimeout(poll, 50);
	      } else {
	        finish('css');
	      }
	    }
	  }

	  return {

	    css: function (urls, callback, obj, context) {
	      load('css', urls, callback, obj, context);
	    },

	    js: function (urls, callback, obj, context) {
	      load('js', urls, callback, obj, context);
	    }

	  };
	})(window, window.document);

	
